//horseUI
//written by Andrew Fiori
//						Elan Dubrofsky
//						Marty Mackenzie
import java.awt.*; // Import various packages
import java.awt.event.*;
import java.applet.Applet;

public class horseUI extends Applet implements ActionListener
{
private int raceNumber=1;				//the race number from when you started playing
Label raceLabel, instructionLabel,creditlabel;	//some labels in the racing screen
Label[] numNormalBet= new Label[6];	//label on racing screen for normal bets
Label[] numQuinBet= new Label[15];	//label on racing screen for quinnella bets
int realHalf, half;			//used for size of the screen and placing stuff
Horse[] stable=new Horse[6];	//the six horses racing
Button[] betButton=new Button[6];	//buttons for placing bets
Button[] quinBetButton=new Button[15];	//buttons for placing quinnella bets
private int[] normalBet=new int[6];	//how much you have bet on normal horses
private int[] quinBet= new int[15];	//how much you have bet on quinnella's
int[] quinellaOdds=new int[15];		//the odds for quinnella
int[] normalOdds=new int[6];		//the odds for normal bet
Button startRaceButton;			//the button to start a race or reset race
Button payOut;							//the button to go to payout screen
int credits;								//the amount of credits
Horse[] thecollection = Stable.makeHorses();	//all the horses from which we randomly choose
int screen=1;				//the variable for keeping track of what screen is displayed
							//1= intro, 2= racescreem, 3=payout
Label[] comment= new Label[6];//the labels for displaying horses comments
Button startButton;			//the button to leave intro screen
Choice denom, howMany;	//choice buttons for  money
Image mule;							//image on introscreen
Image mule1;						//image on payout screen
Image mule2;						//image on payout screen
Label instruction;			//label in intro screen tells what to do
Label type;							//label in introscreen for type of money
Label amount;						//label in introscreen	for amount of money
Button restart;					//button to leave payout screen and go to intro screen
String Sdenom;					//string stores the type of currency being used
RacePanel theRace;			//the panel in which races occur

		//some fonts that are used in some places
final Font introNameFont=new Font("times new roman", Font.BOLD, 100);
final Font bigNameFont=new Font("times new roman", Font.BOLD, 150);
final Font instructionsFont=new Font("arial", Font.PLAIN, 17);
final Font raceFont=new Font("impact", Font.BOLD, 20);
final Font instructionFont=new Font("arial", Font.PLAIN, 20);
final Font textFont=new Font("times new roman", Font.BOLD, 12);
final Font smallTextFont=new Font("times new roman", Font.BOLD, 8);
final Font nameFont=new Font("monaco", Font.BOLD, 11);



	public void init()	//init it sets up intro screen
	{
		realHalf=(this.getSize().height)/2;	//gets the middle of screen
		half=realHalf-8;										//gets base for drawing stuff
		
		Image pics[] = new Image[6];				//the pictures of horses
		pics[0] =  getImage(getCodeBase(),"WHITEHORSE.gif");
		pics[1] =  getImage(getCodeBase(),"BLACKHORSE.gif");
		pics[2] =  getImage(getCodeBase(),"REDHORSE.gif");
		pics[3] =  getImage(getCodeBase(),"BLUEHORSE.gif");
		pics[4] =  getImage(getCodeBase(),"YELLOWHORSE.gif");
		pics[5] =  getImage(getCodeBase(),"GREENHORSE.gif");
		theRace  = new RacePanel(pics);	//creates the panel for race
				//panel not added untill later
		initintro();//go to intro screen		
		}//end init
	public void initintro()	// intro screen stuff
		{
		setLayout(null);
		setBackground(new Color(150,35,0));	//set background
		denom=new Choice();//sets up the choices for type of money
		denom.add("Pennies");
		denom.add("Nickels");
		denom.add("Dimes");
		denom.add("Quarters");
		denom.add("Loonies");
		denom.add("Toonies");
		denom.add("Fivers");
		denom.add("Ten Dollar Bills");
		denom.add("Twennies");
		denom.add("Fitties");
		denom.add("Bordens");
		denom.add("Gold Nuggets");
		denom.setBounds(30,300,100,25);
		denom.select(3);
		add(denom);	//adds the denomination choice
		
		type=new Label("DENOMINATION");//labels the denomination choice
		type.setBounds(25,280, 200,25);
		type.setFont(instructionsFont);
		type.setForeground(new Color(35,0,135));
		add(type);//adds label
		
		howMany=new Choice();	//sets up choice for amount of money
		howMany.add("1");
		howMany.add("8");
		howMany.add("20");
		howMany.add("40");
		howMany.add("60");
		howMany.add("80");
		howMany.add("100");
		howMany.add("150");
		howMany.add("250");
		howMany.add("500");
		howMany.add("1000");
		howMany.add("5000");
		howMany.setBounds(660,300,100,25);
		howMany.select(6);
		add(howMany);//adds the amount of money choice
		
		amount=new Label("STARTING AMOUNT");//labels the amount of money choice
		amount.setBounds(630,280, 300,25);
		amount.setFont(instructionsFont);
		amount.setForeground(new Color(35,0,135));
		add(amount);//adds the label
		
		//the label that tells you what to do at this screen
		instruction=new Label("*Please select with what denmoination you will be betting and how many you want to start with*");
		instruction.setBounds(75,230,1000, 50);
		instruction.setFont(instructionsFont);
		instruction.setForeground(new Color(107,160,0));
		add(instruction);//adds the label
		
		startButton=new Button("START");	//button to leave intro screen
		startButton.setBounds(350,460,100,50);
		startButton.setBackground(Color.gray);
		add(startButton);			//adds button
		startButton.addActionListener(this);//add listener
		
		mule = getImage(getCodeBase(),"Mules.jpg");//attains the image for this screen
			//image will be drawn later
		}//end initintro
	
	public void initrace()//initrace sets up the race screen
	{
		//randomly selecting horses
		int[] randomArray = new int[6];//array used to randomly select horse
		boolean used;//a boolean makes sure same horse not twice in same race
		for (int x=0; x<6; x++)	//goes through each lane
		{	
			randomArray[x] = -1;//initialize
			do{	//keeps looking for a horse until it finds one it hasn't used
			randomArray[x]=(int)((Math.random()*(Stable.numHorses)));//there are Stable.numHorses horses
			used = false;	//initialize
			for (int y=0; y<x; y++)	//checks if that horse already used
				used=used || (randomArray[x]==randomArray[y]);
			}while (used);
		}

		for (int x=0; x<6; x++)	//get the horses out of the pasture and into stable
			stable[x]=thecollection[randomArray[x]];

		int total = 0;		//thing for calculating odds sum of all stats
		int htotal = 0;		//another thing for calculating odds sum of one horse
		int htotal2 = 0;	//sum of stats for another horse
		for(int x = 0; x < 6; x++){//finding total (speed is weighted as more important)
			total += (int) 1.5*stable[x].getSpeed() + stable[x].getAcceleration() + stable[x].getComeback() + stable[x].getLeading();
			}
		for(int x = 0; x < 6; x++){//calculating odds for each horse
			//get total for the horse
			htotal = (int) 1.5*stable[x].getSpeed() + stable[x].getAcceleration() + stable[x].getComeback() + stable[x].getLeading();
			//calculate the actual probability
			float temp = (float) ((total - htotal)/htotal);
			//skew the odds to make ones >5 larger and ones <5 smaller
			float temp2 = (float) (temp*temp/5);
			//assign value to odds
			normalOdds[x] = (int) temp2;
			if(normalOdds[x] <= 1) normalOdds[x] = 2;//make sure odds are at least 2
			}//end normal odds calculating
			
		int quiarrspot = 0;	//which quinnella spot we are at
		for(int x = 0; x < 5; x++){//goes through first number in quinella
			for(int y = x+1; y < 6; y++){	//goes through second number in quinella
				//total for horse 1
				htotal = (int) 1.5*stable[x].getSpeed() + stable[x].getAcceleration() + stable[x].getComeback() + stable[x].getLeading();
				//total for horse 2
				htotal2 = (int) 1.5*stable[y].getSpeed() + stable[y].getAcceleration() + stable[y].getComeback() + stable[y].getLeading();
				//probability that race ends with H1 in first H2 in second
				float p1 = (float) (((float)htotal/total)*((float)htotal2/(total - htotal)));
				//probability that race ends with H2 in first H1 in second
				float p2 = (float) (((float)htotal2/total)*((float)htotal/(total - htotal2)));
				//odds that either event will happen
				float temp = (float) ((1 - (p1 + p2))/(p1+p2));
				//increases odds over 18 decreases under 18
				float temp2 = (float) temp*temp/18;
				//assigns the value
				quinellaOdds[quiarrspot] = (int) temp2;
				//makes sure not less than 2
				if(quinellaOdds[quiarrspot]<=1) quinellaOdds[quiarrspot]=2;
				quiarrspot++;//increments quiarrspot
				}
			}
		//done odds calculating
		
		for(int x=0; x<6; x++)//set up labels for comments
		{
			comment[x]=new Label(stable[x].getComment()); 
			comment[x].setBounds(452, half+70+20*x, 100, 15);
			comment[x].setForeground(Color.blue);
			comment[x].setBackground(new Color(15,200,50));
			comment[x].setFont(new Font("Arial MT condensed light", Font.PLAIN, 10));
			add(comment[x]);
		}
		
		add(theRace);//adds the panel with race in it to screen
		
		setBackground(new Color(15,200,50));//set the background
		
		//the label that displays racenumber
		raceLabel=new Label("Race  "+raceNumber);
		raceLabel.setFont(raceFont);
		raceLabel.setBounds(5, half+13,120,30);
		raceLabel.setForeground(Color.yellow);
		add(raceLabel);
		
		//the label that displays number of credits remaining
		creditlabel=new Label("Credits: "+String.valueOf(credits));
		creditlabel.setFont(raceFont);
		creditlabel.setBounds(600, half+13,190,30);
		creditlabel.setForeground(Color.yellow);
		add(creditlabel);
		
		//label that tells people to bet
		instructionLabel= new Label ("BET NOW");
		instructionLabel.setFont(instructionFont);
		instructionLabel.setBounds(350,half+13,100,30);
		instructionLabel.setForeground(Color.blue);
		add(instructionLabel);
		
		//button to start the race
		startRaceButton=new Button("start");
		startRaceButton.setBounds(725,half+45, 55,65);
		startRaceButton.setFont(instructionFont);
		startRaceButton.setBackground(new Color(15,200,50));
		startRaceButton.setForeground(Color.black);
		startRaceButton.addActionListener(this);
		add(startRaceButton);
		
		//button to go to payout screen
		payOut=new Button("Payout");
		payOut.setBounds(725,half+115, 55,70);
		payOut.setFont(new Font("Arial",Font.BOLD, 12));
		payOut.addActionListener(this);
		payOut.setBackground(new Color(15,200,50));
		payOut.setForeground(Color.black);
		add(payOut);
		payOut.setEnabled(true);
		
		for (int x=0; x<6; x++)//the bet labels that display how much youve bet
		{
			numNormalBet[x]=new Label(" ");
			numNormalBet[x].setBounds(690, half+71+20*x, 30, 10);
			numNormalBet[x].setFont(textFont);
			numNormalBet[x].setForeground(Color.black);
			numNormalBet[x].setBackground(new Color(15,200,50));
			add(numNormalBet[x]);
		}
		
		for (int x=0; x<6; x++)//the bet buttons that let you bet
		{
			betButton[x]=new Button("BET");
			betButton[x].setBounds(642, half+68+20*x, 40, 16);
			betButton[x].addActionListener(this);
			betButton[x].setBackground(new Color(15,200,50));
			betButton[x].setForeground(Color.black);
			add(betButton[x]);
		}
		
		for (int x=0; x<15; x++)//the quinnella bet buttons
		{
			quinBetButton[x]=new Button("BET");
			quinBetButton[x].setBounds(15+50*x, half+253, 40, 16);
			quinBetButton[x].addActionListener(this);
			quinBetButton[x].setBackground(new Color(15,200,50));
			quinBetButton[x].setForeground(Color.black);

			add(quinBetButton[x]);
		}
		
		for(int x=0; x<15; x++)//the labels that tell you how much you've bet on quinnella
		{
			numQuinBet[x]=new Label(" ");
			numQuinBet[x].setBounds(25+50*x, half+275, 30, 10);
			numQuinBet[x].setFont(textFont);
			numQuinBet[x].setForeground(Color.black);
			add(numQuinBet[x]);
		}

		validate();//makes sure stuff is in correct layout
	}//end initrace

	public void payoutInit()//sets up the payout screen
	{
		setBackground(new Color(90,100,200));//sets background
		
		mule1 = getImage(getCodeBase(), "mule.jpg");	//the pictures
		mule2 = getImage(getCodeBase(), "ql-mule.gif");
		
		restart = new Button("Return");			//the button to return to intro screen
		restart.setBounds(310,210,100,50);
		restart.setBackground(Color.green);
		restart.addActionListener(this);
		add(restart);
	}//end payoutinit
	
	public void paint(Graphics g)
	// This is the paint method of the program. It is broken up into three screens
	{
	if(g!= null){ //gets rid of null pointer exceptions
		if (screen==1) // The intro screen
		{
			g.setFont(introNameFont);
			g.setColor(Color.yellow);
			g.drawString("PEASANT", 180,100);
			g.setColor(Color.black);
			g.setFont(bigNameFont);
			g.drawString("MULE", 190,210); // write the name of our glorious program
		
			g.setFont(new Font("Times", Font.BOLD, 14)); // The instructions
			g.drawString("Place your bet on horses and/or on quinellas.",10,350);
			g.drawString("A quinella is a bet on the first and second place",10,380);
			g.drawString("finishers, regardless of order.",10,400);
	  	g.drawString("Look at the odds, choose carfully.",470,350);
	  	g.drawString("Lower odds means less money, better chances.",470,370);
			g.drawString("If you win, the credits you bet are multiplied",470,390);
			g.drawString("by the odds.",470,410);
		
			g.drawImage(mule,340,280,this); // The funny mule picture
		}
	
		if (screen==2) // the bottom half of the race screen
		{	
			theRace.repaint(); // Repaint the race screen to ensure it draws the horses
			validate(); // Well... you know... to make the program work. OBVIOUSLY
			
			// Lines that split up the two halves of the race screen
			g.drawLine(0,realHalf-2,800,realHalf-2);
			g.drawLine(0,realHalf,800,realHalf);
			g.drawLine(0,realHalf+2,800,realHalf+2);
			
			//The horizontal lines that make up the top box (The box that contains the horse information)
			for (int x=0; x<8;x++)
				g.drawLine(0,half+45+x*20,720,half+45+x*20);
			
			// The first column shows the horses number and column
			g.setFont(textFont);
			g.drawString("Number", 10, half+58); // write "number"
			g.drawLine(60,half+45, 60, half+185); // draw the line that ends the column and starts the next one
			g.setColor(Color.white); // the first horse is white
			g.fillRect(13,half+68, 32,16);
			g.setColor(Color.black); // the second horse is black
			g.fillRect(13,half+88, 32,16);
			g.setColor(Color.red); // the third horse is red
			g.fillRect(13,half+108, 32,16);
			g.setColor(Color.blue); // the fourth horse is blue
			g.fillRect(13,half+128, 32,16);
			g.setColor(Color.yellow); // the fifth horse is yellow
			g.fillRect(13,half+148, 32,16);
			g.setColor(Color.green); // the sixth horse is green
			g.fillRect(13,half+168, 32,16);
			for (int x=1; x<7; x++) // an array to write all of the horses numbers
			{
				g.setColor(Color.black); // for the black horse write in white. All the others in black.
				if (x==2)
					g.setColor(Color.white);
				g.drawString(Integer.toString(x),26, half+61+x*20);// the toString method is used to convert the integer to a string
			}

		
			//The second column displays the horses' names
			
			g.drawString("HORSE NAME", 87, half+58); // a nice title for the column
			g.drawLine(200,half+45, 200, half+185);// draw the line that ends the column and starts the next one
			g.setFont(nameFont); 
			
			for(int x=0; x<6; x++) // this loop writes the name after selecting the correct color
			{ 
				if (x==0)
					g.setColor(Color.white);
				else if (x==1)
					g.setColor(Color.black);
				else if (x==2)
					g.setColor(Color.red);
				else if (x==3)
					g.setColor(Color.blue);
				else if (x==4)
					g.setColor(Color.yellow);
				else if (x==5)
					g.setColor(Color.green);		
				g.drawString(stable[x].getName(), 63, half+80+20*x); // The name is attained from the stable array
			}
			
			// The next column displays how many times the horses have come in first, second and have not placed at all.
			g.setFont(textFont);
			g.setColor(Color.black);
			g.drawString("1st      2nd      UN-PLS", 208, half+58); // a nice title for the column
			for(int x=0; x<6; x++) // the information is acquired from the stable array
				g.drawString(Integer.toString(stable[x].getNumFirsts()), 209, half+80+20*x);
			for(int x=0; x<6; x++)
				g.drawString(Integer.toString(stable[x].getNumSeconds()), 243, half+80+20*x);
			for(int x=0; x<6; x++)
				g.drawString(Integer.toString(stable[x].getNumUnplaced()), 290, half+80+20*x);
			g.drawLine(330, half+45, 330, half+185);// draw the line that ends the column and starts the next one
		
			//The next column displays each horses' previous 5 race results
			g.drawString("5 RACE' RESULTS", 337, half+58); // a nice title for the column
			for (int x=0; x<6; x++) // this array draws the last five race results
			{
				// this array reads in the information from the stable array
				int[] order= {stable[x].getFifthLast(), stable[x].getFourthLast(), stable[x].getThirdLast(), stable[x].getSecondLast(), stable[x].getLast()};
					for (int race=4;race>=0;race--) // goes through the order array
					{
						if ( (order[race]==2) || (order[race]==1)) // if the horse placed first or second, cirlce it
						{
							g.setColor(Color.orange); // ORANGLE CIRLCE. WOW!!!!!!!!!!!!!!!!!!!!!!!				
							g.drawOval(337+20*race, half+67+20*x, 15, 17);
						}
						if(order[race] > 0) // If there are results
						{
							g.setColor(Color.black);
							g.drawString(Integer.toString(order[race]), 342+20*race, half+80+20*x);
						}
						else
						{ // if there are no results yet
							g.setColor(Color.black);
							g.drawString(" ", 342+20*race, half+80+20*x);
						}
					}
			}
		
			g.drawLine(448,half+45, 448, half+185); // draw the line that ends the column and starts the next one
		
			//the next column displays the comments for each horse
			// the comments are dealt with in the initrace and actionPerformed methods
			g.drawString("COMMENTS", 452,half+58); // a nice title for the column

			g.setColor(Color.black);
			g.drawLine(555,half+45, 555,half+185);// draw the line that ends the column and starts the next one

		
			// The next column displays the odds for each horse in the current race.
			// Odds are explained on the intro screen and in the manual
			g.setFont(textFont);
			g.drawString("WIN ODDS", 561, half+58); // a nice title for the column
			
			for(int x=0; x<6; x++) // display all six odds
				g.drawString(Integer.toString(normalOdds[x]), 586, half+80+20*x);
			g.drawLine(635,half+45, 635, half+185); // draw the line that ends the column and starts the next one
		
			//The next column contains the bet buttons for each horse
			//These buttons are placed in the initrace and actionPerformed methods 
			g.drawString("BET", 675, half+58);
			g.drawLine(720, half+45, 720, half+185); // draw the line that ends the column and starts the next one
		
		
			// Draw a very nice looking heading above the quinella grid including cool lines
			
			g.setColor(Color.yellow);
			g.drawLine(20,half+197, 290, half+197);		
			g.drawLine(20,half+202, 290, half+202);
			g.setFont(instructionFont);
			g.drawString("QUINELLA ODDS", 295, half+208);
			g.drawLine(460,half+197, 730, half+197);
			g.drawLine(460,half+202, 730, half+202);
		
			//Draw the quinella grid with vertical and horizontal lines
			g.setColor(Color.black);
				//horizontal lines
			for(int x=0; x<5; x++)
				g.drawLine(10, half+215+18*x, 760, half+215+18*x);
				//vertical lines
			for (int x=0; x<16; x++)
				g.drawLine(10+50*x, half+215, 10+50*x, half+287);
			
			//This block of codes writes the different possible quinella results (1-2, 3-4, etc.)
			g.setFont(textFont);
			g.setColor(Color.yellow);
			int counter=0;
			for (int first=1; first<6; first++)
				for (int second=2; second<7; second++)
					if(second>first)
					{
						g.drawString(Integer.toString(first)+"-"+Integer.toString(second), 26+50*counter, half+229); 
						counter++;
					} // not bad eh? Works like a charm. 2 loops and an accumlator. I RULE!!!!!!
			
			// write the quinella odds in the quinella boxes
			g.setColor(Color.black);
			for (int x=0; x<15; x++)
				g.drawString(Integer.toString(quinellaOdds[x]), 27+50*x, half+ 247);
				
			// the quinella buttons are placed elsewhere in the program
			}
			validate(); // I love validate
		
			if (screen==3)	//THE PAYOUT SCREEN
			{
				g.setFont(new Font("Klang MT", Font.BOLD, 80));		//some text for payout screen
				g.setColor(Color.yellow);
				g.drawString("MONEY TROUGH",80,130 ); // The noble title of the payout screen
	
				g.setFont(new Font("Klang MT", Font.BOLD, 20));		//Display how many (fill in denomination) the user ended up with
				g.setColor(Color.orange);
				g.drawString("You ended up with "+ credits+" "+Sdenom,220,170);
	
				g.setColor(new Color(207,136,36));	// Draw the bucket that the money comes out of
				g.fillRoundRect(310,280,100,150,10,10);
				g.drawLine(310,410,300,430);
				g.drawLine(300,430,420,430);
				g.drawLine(410,410,420,430);
		
				g.setColor(Color.red);	// draw text on the bucket
				g.setFont(new Font("Klang MT", Font.BOLD, 20));
				g.drawString("TROUGH", 320,350);
				g.setColor(Color.green);
				g.drawString("$",315,300); // Cool dollar signs on the bucket
				g.drawString("$",395,300);
				g.drawString("$",315,420);
				g.drawString("$",395,420);
			
				g.setColor(Color.red); // This important block of code gives credit to the genious programmers
				g.drawString("Created by:",590,180);
				g.drawString("Marty",590,210);
				g.drawString("Elan and",590,240);
				g.drawString("Andrew",590,270);
			
				if (credits!=0) // as long as the user has money to cash out, money is randomly drawn falling out of the bucket
				{
													
					g.setFont(new Font("times",0,11));
			
					for(int a=0; a<18;a++)		//randomly places silver coins
					{
						int x, y;	
						x=(int)(310+Math.random()*100);	//location
						y=(int)(450+Math.random()*100);
						g.setColor(Color.gray);					//draws coin
						g.fillOval(x,y,10,10);
					}
			
					for(int a=0; a<8;a++)	//randomly places gold coins
					{
						int x, y;
						x=(int)(310+Math.random()*100);	
						y=(int)(450+Math.random()*100);
						g.setColor(Color.yellow);				//draws coin
						g.fillOval(x,y,15,15);
					}
			
					for(int a=0; a<5;a++)//randomly places bills
					{
						int x,y;
						x=(int)(310+Math.random()*100);//location
						y=(int)(450+Math.random()*100);
						g.setColor(Color.green);				//draws bill
						g.fillRect(x,y,20,10);
						g.setColor(Color.black);
						g.drawString("$",x+7,y+9);
					}
				}
			
				g.drawImage(mule1,10,250,this);				//draws images of mules
				g.drawImage(mule2,480,300,this);
			
				validate(); // VALIDATE! If you break it up you get: I date Val. If we're talking about Valory Irons from VIP... I'M IN!
			
			} 
		}	
	}//end paint
	
	public void actionPerformed(ActionEvent e)//responds to buttons being pushed
	{
		if (e.getSource().equals(startButton)) // start button from intro screen
		{
			//find out what choice of credits they made
			credits = Integer.parseInt(howMany.getSelectedItem());	
			Sdenom =  denom.getSelectedItem(); //finds out denomination
			screen=2;	//says we are going to the race screen
			remove(denom);		//removes all the labels and buttons from introscreen
			remove(howMany);
			remove(instruction);
			remove(type);
			remove(amount);
			remove(startButton);
			initrace();			//goes and sets up race
			repaint();			//repaints screen twice because sometimes it forgets stuff 
			repaint();			//on the first time
		}//end if clicked on button to leave introscreen
		
		if(e.getSource().equals(startRaceButton)&&e.getActionCommand().equals("start"))
		{//if clicked start race button in start race mode
			for (int x=0; x<15; x++)//disable bet buttons
				quinBetButton[x].setEnabled(false);
			for (int x=0; x<6; x++)//disable bet buttons
				betButton[x].setEnabled(false);
			startRaceButton.setEnabled(false);//disable start race button
			payOut.setEnabled(false);			//disable payout button
				
			theRace.race(stable);//have a race with horses in stable
		
			//check if you made money
			for(int i = 0; i< 6; i++){//go through the horses
					if(theRace.getFinalPosition(1) ==  (i+1)){
							credits +=  normalBet[i]*normalOdds[i]; //increases money based on bet
							betButton[i].setForeground(Color.red);	//makes winning button turn red
							betButton[i].setEnabled(true);	//disable then enable button so that
							betButton[i].setEnabled(false);	//you see the color change
							betButton[i].validate();				//makes sure button color changes
							}
					}//done checking normal bets
			int k = 0;//for going through the quinnella
			for(int i = 1; i< 7; i++){//goes through first quin number
					for(int j = i+1; j<7; j++){//goes through second quin number
						  if(((theRace.getFinalPosition(1) ==  i)&&(theRace.getFinalPosition(2) ==  j))||((theRace.getFinalPosition(1) ==  j)&&(theRace.getFinalPosition(2) ==  i))){
							  	//if that quinnella won
							  	credits+= quinBet[k]*quinellaOdds[k];	//increments money based on bet
							  	quinBetButton[k].setForeground(Color.red);//makes winning button turn red
							  	quinBetButton[k].setEnabled(true);		//disable then enable button so that
							  	quinBetButton[k].setEnabled(false);		//you see the color change
							  	quinBetButton[k].validate();					//makes sure button color changes
							 		}
						  k++;//increment spot in array
						}
				}	//done checking quinnella bets
				 
				 //shows the updated credits on screen
				creditlabel.setText("Credits: "+String.valueOf(credits)); 
				
				for (int x=0; x<6; x++)//updates the statistics
					stable[theRace.getFinalPosition(x+1)-1].setFinished(x+1);
				
				startRaceButton.setLabel("reset");//sets the start race button to reset mode
				startRaceButton.setEnabled(true);	//enables reset button
				repaint();	//repaints the screen
				validate();	//validates
			}//end start button in start mode
		if(e.getSource().equals(startRaceButton)&&e.getActionCommand().equals("reset")){
			//if pressed start race button in reset mode
			startRaceButton.setEnabled(false);//disables the button
			
			for (int x=0; x<15; x++){//goes through quinella bet buttons
				quinBetButton[x].setForeground(Color.black);	//makes the red one black
				quinBetButton[x].setEnabled(true);		//enables the buttons
				quinBetButton[x].validate();					//validate to make sure stuff changes
				quinBet[x] = 0;												//resets bet to zero
				numQuinBet[x].setText(" ");//resets text on how much you've bet
				}
			for (int x=0; x<6; x++){//goes through normal bet buttons
				betButton[x].setForeground(Color.black);//makes the red one black
				betButton[x].setEnabled(true);//enables the buttons
				betButton[x].validate();			//validate to make sure stuff changes
				normalBet[x] = 0;							//resets bet to zero
				numNormalBet[x].setText(" ");	//resets text on how much youve bet
				}
				
			theRace.resetRace();		//resets the racepanel
			
		//randomly selecting new horses
		int[] randomArray = new int[6];//array used to randomly select horse
		boolean used;//a boolean makes sure same horse not twice in same race
		for (int x=0; x<6; x++)	//goes through each lane
		{	
			randomArray[x] = -1;//initialize
			do{	//keeps looking for a horse until it finds one it hasn't used
			randomArray[x]=(int)((Math.random()*(Stable.numHorses)));//there are Stable.numHorses horses
			used = false;	//initialize
			for (int y=0; y<x; y++)	//checks if that horse already used
				used=used || (randomArray[x]==randomArray[y]);
			}while (used);
		}

		for (int x=0; x<6; x++)	//get the horses out of the pasture and into stable
			stable[x]=thecollection[randomArray[x]];

		int total = 0;		//thing for calculating odds sum of all stats
		int htotal = 0;		//another thing for calculating odds sum of one horse
		int htotal2 = 0;	//sum of stats for another horse
		for(int x = 0; x < 6; x++){//finding total (speed is weighted as more important)
			total += (int) 1.5*stable[x].getSpeed() + stable[x].getAcceleration() + stable[x].getComeback() + stable[x].getLeading();
			}
		for(int x = 0; x < 6; x++){//calculating odds for each horse
			//get total for the horse
			htotal = (int) 1.5*stable[x].getSpeed() + stable[x].getAcceleration() + stable[x].getComeback() + stable[x].getLeading();
			//calculate the actual probability
			float temp = (float) ((total - htotal)/htotal);
			//skew the odds to make ones >5 larger and ones <5 smaller
			float temp2 = (float) (temp*temp/5);
			//assign value to odds
			normalOdds[x] = (int) temp2;
			if(normalOdds[x] <= 1) normalOdds[x] = 2;//make sure odds are at least 2
			}//end normal odds calculating
			
		int quiarrspot = 0;	//which quinnella spot we are at
		for(int x = 0; x < 5; x++){//goes through first number in quinella
			for(int y = x+1; y < 6; y++){	//goes through second number in quinella
				//total for horse 1
				htotal = (int) 1.5*stable[x].getSpeed() + stable[x].getAcceleration() + stable[x].getComeback() + stable[x].getLeading();
				//total for horse 2
				htotal2 = (int) 1.5*stable[y].getSpeed() + stable[y].getAcceleration() + stable[y].getComeback() + stable[y].getLeading();
				//probability that race ends with H1 in first H2 in second
				float p1 = (float) (((float)htotal/total)*((float)htotal2/(total - htotal)));
				//probability that race ends with H2 in first H1 in second
				float p2 = (float) (((float)htotal2/total)*((float)htotal/(total - htotal2)));
				//odds that either event will happen
				float temp = (float) ((1 - (p1 + p2))/(p1+p2));
				//increases odds over 18 decreases under 18
				float temp2 = (float) temp*temp/18;
				//assigns the value
				quinellaOdds[quiarrspot] = (int) temp2;
				//makes sure not less than 2
				if(quinellaOdds[quiarrspot]<=1) quinellaOdds[quiarrspot]=2;
				quiarrspot++;//increments quiarrspot
				}
			}
		//done odds calculating
		
		for (int x=0; x<6; x++) //changing the text for the comments
			comment[x].setText(stable[x].getComment());
				
			raceNumber++;			//increments the race number
			raceLabel.setText("Race  "+raceNumber); //displays new race number
			
			startRaceButton.setLabel("start");//sets race button to start race mode
			startRaceButton.setEnabled(true);	//enable the button
			payOut.setEnabled(true);					//enable payout button
			repaint();					//repaints
			validate();					//validates
			}//end start button in reset mode button
		if(e.getSource().equals(payOut))	//if they clicked payout button
		{
			for (int x=0; x<6; x++)		//remove buttons and labels
			{	
				remove(comment[x]);
				remove(numNormalBet[x]);
				remove(betButton[x]);
			}
			for (int x=0; x<15; x++)	
			{
				remove(quinBetButton[x]);
				remove(numQuinBet[x]);
			}
			remove(theRace);		//remove the race panel
			remove(raceLabel);		//remove more buttons and labels from race screen
			remove(creditlabel);
			remove(instructionLabel);
			remove(startRaceButton);
			remove(payOut);
			validate();			//validates
			payoutInit();	//sets up the payout screen
			screen=3;			//sets our screen to payout
			repaint();		//repaints
		}//done start race button in reset mode
		if(e.getSource().equals(restart))	//if clicked to return to intro from payout
		{
			remove(restart);			//removes button
			screen=1;							//sets the screen
			initintro();					//sets up intro screen
			repaint();						//repaints
		}//done restart button from payout screen
		
	if(credits>0){//only lets you bet if you have money
		for(int x=0; x<6; x++)	//goes through the bet buttons to see if they were clicked
			if (e.getSource().equals(betButton[x])) //check normal bet buttons
			{
				normalBet[x]++;		//increments your bet
				//shows your bet on screen
				numNormalBet[x].setText(Integer.toString(normalBet[x]));
				credits--;				//decreases credits
				//shows your credits on screen
				creditlabel.setText("Credits: "+String.valueOf(credits));	
				}	//done checking normal bet buttons
			
		for(int x=0; x<15; x++)//checking quinnella bet buttons
			if(e.getSource().equals(quinBetButton[x]))
			{
				quinBet[x]++;//increments your bet
				//shows your bet on screen
				numQuinBet[x].setText(Integer.toString(quinBet[x]));
				credits--;//decreases credits
				//shows your credits on screen
				creditlabel.setText("Credits: "+String.valueOf(credits));
				}//done checking quinnella bet buttons
			}//done checking bet buttons
	}//end action performed

}//end of class horseUI